#include "AddInServerIDisp.h"
namespace InventorNative{

	CAddInServerIDisp::CAddInServerIDisp() :m_cRef(1){}

	HRESULT __stdcall CAddInServerIDisp::QueryInterface(const IID& iid,
														void **ppv)
	{
		if (iid == IID_IUnknown)
		{
			*ppv = static_cast<IUnknown*>(this);
		}
		else if (iid == IID_IDispatch)
		{
			*ppv = static_cast<IDispatch*>(this);
		}
		else if (iid == DIID_ApplicationAddInServer)
		{
			*ppv = static_cast<ApplicationAddInServer*>(this);
		}
		else
		{
			*ppv = __nullptr; return E_NOINTERFACE;
		}
		reinterpret_cast<IUnknown*>(*ppv)->AddRef();
		return S_OK;
	}

	ULONG __stdcall CAddInServerIDisp::AddRef()
	{
		return InterlockedIncrement(&m_cRef);
	}
	ULONG __stdcall CAddInServerIDisp::Release()
	{
		if (InterlockedDecrement(&m_cRef) == 0)
		{
			delete this;
			return 0;
		}
		return m_cRef;
	}

	HRESULT __stdcall CAddInServerIDisp::GetTypeInfoCount(UINT *pctinfo)/*[out]*/
	{ *pctinfo = 1; return S_OK; }

	HRESULT __stdcall CAddInServerIDisp::GetTypeInfo(UINT iTInfo,/*[in]*/
													 LCID lcid,/*[in]*/
													 ITypeInfo **ppTInfo)/*[out]*/
	{
		return S_OK;
	}

	HRESULT __stdcall CAddInServerIDisp::GetIDsOfNames(const IID& riid,/*[in]*/
													   LPOLESTR *rgszNames,/*[size_is][in]*/
													   UINT cNames, /*[range][in]*/
													   LCID lcid,/*[in]*/
													   DISPID *rgDispId)/*[size_is][out]*/
	{
		return S_OK;
	}


	HRESULT __stdcall CAddInServerIDisp::Invoke(DISPID dispIdMember,/*[in]*/
												const IID& riid,/*[in]*/
												LCID lcid,/*[in]*/
												WORD wFlags,/*[in]*/
												DISPPARAMS *pDispParams,/*[out][in]*/
												VARIANT *pVarResult,/*[out]*/
												EXCEPINFO *pExcepInfo,/*[out]*/
												UINT *puArgErr)/*[out]*/
	{
		//   MethodActivate
		if (dispIdMember == 0x03001201)
		{
			VARIANT* pfirstTime = pDispParams->rgvarg;//FirstTime
			VARIANT*  pDispAddInSite = pfirstTime + 1;//ApplicationAddInSite
			ApplicationAddInSite * pAddInSite = reinterpret_cast<ApplicationAddInSite*>(pDispAddInSite->pdispVal);
			this->MethodActivate(pAddInSite, pfirstTime->boolVal);
		}
		//   MethodDeactivate
		else if (dispIdMember == 0x03001202)
		{ this->MethodDeactivate(); }
		//   MethodExecuteCommand
		else if (dispIdMember == 0x03001203)
		{ this->MethodExecuteCommand(0); }//  ( )
		//   GetAutomation
		else if (dispIdMember == 0x03001204)
		{
			VariantInit(pVarResult);
			pVarResult->vt = VT_DISPATCH;
			pVarResult->pdispVal = this->GetAutomation();
		}

		return S_OK;
	}
	HRESULT __stdcall CAddInServerIDisp::MethodActivate(ApplicationAddInSite * pAddInSite, VARIANT_BOOL FirstTime)
	{
		HRESULT hr = pAddInSite->get_Application(&m_pInvApp);
		HRESULT Result = NOERROR;
		// 
		CComBSTR bstrCaption;
		Result = m_pInvApp->get_Caption(&bstrCaption);
		//  
		CComBSTR bstrMsgText(L"IDispatch C++:  ");
		bstrMsgText.AppendBSTR(bstrCaption);
		// 
		int msgboxID = MessageBoxW(__nullptr, bstrMsgText, L"", MB_OK);
		return S_OK;
	}

	HRESULT __stdcall CAddInServerIDisp::MethodDeactivate()
	{ return S_OK; }

	HRESULT __stdcall CAddInServerIDisp::MethodExecuteCommand(long CommandID)
	{ return S_OK; }

	IDispatchPtr __stdcall  CAddInServerIDisp::GetAutomation()
	{ return __nullptr; }
}