#include "ClassFactory.h"
#include "AddInServerIDisp.h"

HRESULT __stdcall	CClassFactory::QueryInterface(const IID& iid, void** ppv)
{
	if (iid == IID_IUnknown)
	{
		*ppv = static_cast<IUnknown*>(this);
	}
	else if (iid == IID_IClassFactory)
	{
		*ppv = static_cast<IClassFactory*>(this);
	}
	else
	{
		*ppv = __nullptr;
		return E_NOINTERFACE;
	}
	reinterpret_cast<IUnknown*>(*ppv)->AddRef();
	return S_OK;
}

ULONG __stdcall CClassFactory::AddRef()
{ return InterlockedIncrement(&m_cRef); }

ULONG __stdcall CClassFactory::Release()
{
	if (InterlockedDecrement(&m_cRef) == 0)
	{
		delete this;
		return 0;
	}
	return m_cRef; 
}

HRESULT __stdcall CClassFactory::CreateInstance(IUnknown* pUnknownOuter,
												const IID& iid,
												void** ppv)
{	//   
	if (pUnknownOuter != __nullptr)
	{return CLASS_E_NOAGGREGATION;}
	//  
	InventorNative::CAddInServerIDisp* pAddInServer = new InventorNative::CAddInServerIDisp;
	HRESULT hr = NOERROR;
	//   
	 hr = pAddInServer->QueryInterface(iid, ppv);
	//    IUnknown
	// (   QueryInterface    )
	pAddInServer->Release();
	return hr;
}

HRESULT __stdcall CClassFactory::LockServer(BOOL bLock){ return S_OK; }

CClassFactory::CClassFactory() : m_cRef(1) {}