#include "Module.h"
#include "ClassFactory.h"

//  
HMODULE g_hModule = __nullptr;
long g_cComponents = 0;

//CLSID  {24AE65B5-65A9-40C9-9D5C-20DAD4738559}
const GUID CLSID_component =
{ 0x24ae65b5, 0x65a9, 0x40c9, { 0x9d, 0x5c, 0x20, 0xda, 0xd4, 0x73, 0x85, 0x59 } };


BOOL __stdcall  DllMain(HMODULE hModule, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		g_hModule = hModule;
		g_cComponents++;
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		g_cComponents--;
	}
	return TRUE;
}

HRESULT __stdcall DllGetClassObject(const CLSID& clsid, const IID& iid, void** ppv)
{
	//     
	if (clsid != CLSID_component)
	{ return CLASS_E_CLASSNOTAVAILABLE; }

	//   
	CClassFactory* pFactory = new CClassFactory;

	//   
	HRESULT hr = pFactory->QueryInterface(iid, ppv);
	pFactory->Release();
	return hr;
}

HRESULT __stdcall DllCanUnloadNow()
{
	if (g_cComponents == 0)
	{
		return S_OK;
	}
	else
	{
		return S_FALSE;
	}
}
