#include "AddInServerIUnk.h"
#include <atlbase.h>
namespace InventorNative{

	HRESULT __stdcall CAddInServerIUnk::QueryInterface(const IID& iid,
													   void **ppv)
	{
		if (iid == IID_IUnknown)
		{
			*ppv = static_cast<IUnknown*>(this);
		}
		else if (iid == IID_IRxApplicationAddInServer)
		{
			*ppv = static_cast<IRxApplicationAddInServer*>(this);
		}
		reinterpret_cast<IUnknown*>(*ppv)->AddRef();
		return S_OK;
	}

	ULONG __stdcall CAddInServerIUnk::AddRef()
	{
		return InterlockedIncrement(&m_cRef);
	}
	ULONG __stdcall CAddInServerIUnk::Release()
	{
		if (InterlockedDecrement(&m_cRef) == 0)
		{
			delete this;
			return 0;
		}
		return m_cRef;
	}

	HRESULT __stdcall CAddInServerIUnk::raw_Activate(IRxApplicationAddInSite * pAddInSite, BooleanType FirstTime)
	{
		if (pAddInSite == NULL) return E_INVALIDARG;
		// IUnknown 
		IUnknown* pAppUnk;
		HRESULT hr = pAddInSite->get_Application(&pAppUnk);
		if (FAILED(hr)) return hr;
		// -
		hr = pAppUnk->QueryInterface(&m_pInvApp);
		// 
		CComBSTR bstrCaption;
		hr = m_pInvApp->get_Caption(&bstrCaption);
		//  
		CComBSTR bstrMsgText(L"IUnknown C++:  ");
		bstrMsgText.AppendBSTR(bstrCaption);
		// 
		int msgboxID = MessageBoxW(__nullptr, bstrMsgText, L"", MB_OK);
		return S_OK;
	}

	HRESULT __stdcall CAddInServerIUnk::raw_Deactivate()
	{
		g_cComponents--;//    ( DLL)
		this->Release();//     ( )
		return S_OK;
	}
	// ,     
	HRESULT __stdcall CAddInServerIUnk::raw_ExecuteCommand(long CommandID)
	{ return S_OK; }

	HRESULT __stdcall CAddInServerIUnk::get_Automation(IUnknown **ppResult)
	{ ppResult = __nullptr;  return S_OK; }

	CAddInServerIUnk::CAddInServerIUnk() :m_cRef(1){}
}