#include "Module.h"
#include "ClassFactory.h"

//  
HMODULE g_hModule = __nullptr;
long g_cComponents = 0;

//CLSID  {3AD1A692-1E0F-4A12-9AD6-20B0512CE743}
const IID CLSID_component = { 0x3ad1a692, 0x1e0f, 0x4a12,
{ 0x9a, 0xd6, 0x20, 0xb0, 0x51, 0x2c, 0xe7, 0x43 } };


BOOL __stdcall  DllMain(HMODULE hModule, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		g_hModule = hModule;
		g_cComponents++;
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		g_cComponents--;
	}
	return TRUE;
}

HRESULT __stdcall DllGetClassObject(const CLSID& clsid, const IID& iid, void** ppv)
{
	//     
	if (clsid != CLSID_component)
	{ return CLASS_E_CLASSNOTAVAILABLE; }

	//   
	CClassFactory* pFactory = new CClassFactory;

	//   
	HRESULT hr = pFactory->QueryInterface(iid, ppv);
	pFactory->Release();
	return hr;
}

HRESULT __stdcall DllCanUnloadNow()
{
	if (g_cComponents == 0)
	{
		return S_OK;
	}
	else
	{
		return S_FALSE;
	}
}
